searchNodes=[{"doc":"Tags the current commit with the version specified in the Mix file","ref":"Mix.Tasks.Tag.html","title":"Mix.Tasks.Tag","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Tag.html#run/1","title":"Mix.Tasks.Tag.run/1","type":"function"},{"doc":"Point-to-point, durable message-queues as GenStage producers. Stagger enables the creation of GenStage processes that enqueue terms to simple, file-backed message-queues, allowing the producer and consumer to run independently of each other, possibly at different times. + -- -- -- -- -- + + -- -- -- -- -- + + -- -- -- -- -- + + -- -- -- -- -- -- + | Upstream | | MsgQueue | | MsgQueue | | Downstream | | | -&gt; | | &lt;- | | &lt;- -- &gt; | | | Client | | Producer | | Consumer | | Processing | + -- -- -- -- -- + + -- -- -- -- -- + + -- -- -- -- -- + + -- -- -- -- -- -- + | | read write | | + -- -- -- + | FILE | | | | | + -- -- -- + Your upstream client writes its events into the message-queue (provided by Stagger), which persists them to local storage. Your (GenStage) consumer, subscribes to the producer and receives events, via this local storage. Producers Upstream clients must first open their message-queue, via open/1 , and then use the resulting process to enqueue writes, via write/2 . { :ok , pid } = Stagger . open ( &quot;/path/to/msg/queue&quot; ) ... :ok = Stagger . write ( pid , &quot;foo&quot; ) :ok = Stagger . write ( pid , &quot;bar&quot; ) :ok = Stagger . write ( pid , &quot;baz&quot; ) The process created via open/1 is the GenStage MsgQueue - by writing entries to it, it will satisfy demand from a downstream consumer. Consumers Downstream clients are GenStage consumers. They must also open the message-queue, via open/1 and then subscribe use existing GenStage subscription facilities: def init ( args ) do { :ok , pid } = Stagger . open ( &quot;/path/to/msg/queue&quot; ) { :ok , sub } = GenStage . sync_subscribe ( self ( ) , to : pid , ack : last_processed ( ) ) ... end def handle_events ( events , _from , stage ) do ... end Sequence numbers Sequence numbers are used to control the events seen by a subscriber. Every event delivered to a consumer is a 2-tuple of {seqno, msg} and it is the consumer's responsibility to successfully record this sequence number as having been processed. A consumer must indicate its last-processed sequence number by passing ack: N in the subscription options (pass ack: 0 when no such number exists) whenever it (re)subscribes. Event delivery will resume from the Nth + 1 event. Every message written to the message-queue is assigned an incrementing sequence number by the Stagger process. When an existing message queue is re-opened, the process will first recover the last written number, using that as the base for any subsequent writes. Purging In order to prevent unconstrained growth of the message-queue file, a consumer may periodically purge the queue of old entries by passing a purge: N option when it (re)subscribes e.g: last = last_processed ( ) { :ok , sub } = GenStage . sync_subscribe ( self ( ) , to : pid , ack : last , purge : last ) All entries up to and including N are removed from the head of message-queue file. The value of N will be capped to no more than the value of the last ack'd message. To summarize: ack: N determines that the next delivered message will have a seqno of N + 1 purge: M is a hint to the producer to remove messages 1..M from the head of the message queue. Why not RabbitMQ? If you think you need something like RabbitMQ, you probably do :-). Stagger is intended to be a lightweight durable message queue with minimal dependencies.","ref":"Stagger.html","title":"Stagger","type":"module"},{"doc":"Open a message-queue file, returning the pid responsible for managing it. The resulting pid can be used by upstream clients to enqueue messages via write/2 , or may be used as the target of a GenStage subscribe operation. The following option may be passed to the function: hibernate_after: N - After a period of N milliseconds, the returned process will hibernate. If unspecified, defaults to 15 seconds. Pass hibernate_after: :infinite to inhibit this behaviour. This option only takes effect if the process managing the queue is created by the call to open/2 .","ref":"Stagger.html#open/2","title":"Stagger.open/2","type":"function"},{"doc":"Write a term to the message-queue.","ref":"Stagger.html#write/3","title":"Stagger.write/3","type":"function"}]